Package: nitpick
Depends: amsmercury, iwrlars
Type: Package
Title: NITPICK implementation for peak picking in MS spectra
Version: 2.0
Date: 2007-08-21
Author: Bernhard Renard, Marc Kirchner
Maintainer: Marc Kirchner <marc.kirchner@iwr.uni-heidelberg.de>
Description: STRAP implementation for peak picking in MS spectra
License: LGPL v2.0 or any later version
Packaged: Thu Nov 27 17:59:33 2008; brenard

# Publication script 


library(nitpick)


##real data

##load spectrum 2xN matrix of 
spectrum<-read.table("TOF-MS-yylBSAstd-sample4-23.817-29.278-rebinned.txt")

#adjust spectrum for relevant region detection to not have zero entries (and thus increase robustness)
minSpec<-min(spectrum[spectrum[,2]>0,2])
spectrum[,2]<-spectrum[,2]+minSpec

#relevant region detection
rr<-ams.pp.getRegions.MeanFilter(spectrum,30,15,5)


resultList<-matrix(nrow=0,ncol=4)

##bin data according to relevant regions
bins<-matrix(nrow=1,ncol=3)
bins[1,1]<-rr[1]
bins[1,2]<-1
nextn<-1
addBins<-matrix(nrow=1,ncol=3)

for (j in 2:length(rr))
{  if(rr[j]!=rr[j-1])
  {bins[nextn,3]<-j-1
   nextn<-nextn+1
   addBins[1,1]<-rr[j]
   addBins[1,2]<-j
   addBins[1,3]<-j
   bins<-rbind(bins,addBins)
 }
}

bins[nextn,3]<-length(rr)

bins[bins[,3]==bins[,2],3]<-bins[bins[,3]==bins[,2],3]+2
bins[(bins[,3]-bins[,2])<2,3]<-bins[(bins[,3]-bins[,2])<2,3]+1
#bins[bins[,3]==bins[,2],1]<-1
#bins[(bins[,3]-bins[,2])<2,1]<-1


  lengthBinsOld<-0
      while(length(bins)!=lengthBinsOld)
        {lengthBinsOld<-length(bins)
         bins<-joinAdjacent(bins)
        }



## actual peak detection for each bin featuring a relevant signal

for(n in 1:length(bins[,1]))
{
if(bins[n,1]==0)
{
kong<-ams.pp.buildModelMatrix(bins[n,2],bins[n,3],50,spectrum,EFA=FALSE,charge=c(1,2,3,4,5,6),width=0.00008,maxRangeSize=10)
fooResult<-predict(kong,EFA=FALSE,spectrum,includingZero=FALSE,gdf=TRUE,bic.steps=0)
fight<-ams.pp.listPeaks(fooResult,kong$iCollection)
resultList<-rbind(resultList,fight)
}
}
#save result and run postprocessing
save(resultList,file="0resultList_width_0.00008.rda")
runPostProc(0.00008,0,30,"0resultList_width_0.00008.rda",pathOut="",mz.bin=spectrum[,1], chargestates=c(1,2,3,4,5,6))
load("pp_resultList__30_0.08.RDA")
pp_resultList_BS<-cbind(spectrum[pp_resultList[,1],1],pp_resultList[,2:3])
save(pp_resultList_BS,file="0pp_resultList_g_30width0.08.RDA")




##simulation


load("mz.bins.500-700.equispaced11.rda")


runSim<-function(SNR,Nu,thresh,width,path,charge, limit,EFA=TRUE,hierarchical=FALSE,gdf=TRUE,bic.steps=0,maxRangeSize=10){
	#make result vectors
	resultList<-matrix(nrow=0,ncol=4)
	lengthResultList<-vector(length=Nu)
	inCorrectList<-list()
	correct<-vector(length=Nu)
	tooMany<-vector(length=Nu)
	errsRss.tp<-vector(length=Nu)
	sumFrzl<-vector(length=Nu)
	sumBeta<-vector(length=Nu)               
	numberSimple<-vector(length=Nu)


       #load data
	load("relevantRegions-uniprot_sprot-HUMAN-tryptic-equispaced11-500-700-charge-1-N-500-k-20.rda")

	load("uniprot_sprot-HUMAN-tryptic-equispaced11-500-700-charge-1-N-500-k-20.rda")

	load(paste("uniprot_sprot-HUMAN-tryptic-equispaced11-500-700-charge-1-N-500-k-20-spectra-SNR-",SNR,".rda",sep=""))
	
	load("mz.bins.500-700.equispaced11.rda") 

	#define bins
	for(i in 1:Nu)
	{
		resultList2<-matrix(nrow=0,ncol=4)

		bins<-matrix(nrow=1,ncol=3)
		bins[1,1]<-rr[i,1]
		bins[1,2]<-1
		nextn<-1
		addBins<-matrix(nrow=1,ncol=3)

		for (j in 2:length(rr[i,]))
		{  if(rr[i,j]!=rr[i,j-1])
	         {bins[nextn,3]<-j-1
	          nextn<-nextn+1
	          addBins[1,1]<-rr[i,j]
	          addBins[1,2]<-j
	          addBins[1,3]<-j
		  bins<-rbind(bins,addBins)
	         }
		}

		bins[nextn,3]<-length(rr[i,])
		dat<-cbind(mz.bins,N$S[i,])

		#for each bin, run strap
		for(n in 1:length(bins[,1]))
			{
				if(bins[n,1]==0)
				{
					kong<-ams.pp.buildModelMatrix(bins[n,2],bins[n,3],100,dat,EFA=EFA,charge=charge,width=width,maxRangeSize=maxRangeSize)
					fooResult<-predict(kong,EFA=EFA,dat,includingZero=hierarchical,gdf=gdf,bic.steps=bic.steps)
					fight<-ams.pp.listPeaks(fooResult,kong$iCollection)
					resultList2<-rbind(resultList2,fight)
				}
			}	

		result<-resultList2
		

		print(result)

		#obtaining ground Truth
		breaks<-ams.pp.bins2breaks(mz.bins)
		m0<-findInterval(samples$info[5][((i-1)*20+1):(i*20),1],breaks)
		zInfo<-samples$info[6][((i-1)*20+1):(i*20),1]
		intensity<-samples$info[7][((i-1)*20+1):(i*20),1]
		groundTruth<-matrix(0,nrow=20,ncol=3)
		#Calculating tpr and fpr
		for(j in 1:20)
			{groundTruth[j,]<-cbind(m0[j],zInfo[j],intensity[j])
			}
		print(groundTruth)
		est.TPs.idx<-matrix(0,nrow=0,ncol=3)
		idfyerSet<-NULL
		for (k in 1:20)
		{
		  if (sum(cbind(groundTruth[k,1],groundTruth[k,2]) %in% result[,1:2])==2)
		    {correct[i]<-correct[i]+1
		     idfyer<-which(   (result[,1]==groundTruth[k,1]) & (result[,2]==groundTruth[k,2]) )
		     est.TPs.idx<-rbind(est.TPs.idx,cbind(result[idfyer,1],result[idfyer,2],result[idfyer,3]))
		     idfyerSet<-cbind(idfyerSet,idfyer)
		    }
		    else
		    {inCorrectList<-c(inCorrectList, cbind(groundTruth[k,], i))
		    }
		}
		if(!is.null(idfyerSet))
		{
			falseResult<-result[-idfyerSet,,drop=F]
		}
		else
		{
			falseResult<-result
		}
		print(falseResult)
		tooMany[i]<-length(falseResult[,1])

		#store results
		#resultList<-list(resultList,result)
		resultList<-rbind(resultList,result)
		lengthResultList[i]<-length(result)/4
		#beta gewurschtel quantitativ
		beta <- NULL;
		for (n in 1:length(est.TPs.idx[,1])) {
			# find corresponding peak in sample set
			 c.idx <- which(groundTruth[,1] == est.TPs.idx[n,1]);
			 true.beta <- sum(groundTruth[c.idx,3]); # guard against multiple peaks
			 beta <- rbind(beta, c(est.TPs.idx[n,3], true.beta))
		}
		betasum <- apply(beta,2,sum);
		errsRss.tp [i]<- sum((beta[,1]/betasum[1] - beta[,2]/betasum[2])^2);
		# linus
		frzl <- rbind(beta, cbind(result[!(result[,1] %in% est.TPs.idx[,1]),3] ,rep(0,sum(!(result[,1] %in% est.TPs.idx[,1])))))#tooMany[i])));
		frzl <- t(t(frzl)/apply(frzl,2,sum));
		#browser();
		errsRss.tp[i]<-(sum((frzl[,1]-frzl[,2])^2) / (1/correct[i]*errsRss.tp[i]*(length(result[,1]))))-1#ncol(pq.truth))) -1
		sumFrzl[i]<-sum((frzl[,1]-frzl[,2])^2)
		sumBeta[i]<-sum((beta[,1]/betasum[1] - beta[,2]/betasum[2])^2);
	
	
	
	}
	save(correct,file=paste(path,"correct_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	save(tooMany,file=paste(path,"tooMany_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	save(inCorrectList,file=paste(path,"inCorrectList_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	save(sumFrzl,file=paste(path,"sumFrzl_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	save(sumBeta,file=paste(path,"sumBeta_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	save(resultList,file=paste(path,"resultList_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	save(lengthResultList,file=paste(path,"lengthResultList_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	save(errsRss.tp,file=paste(path,"errs_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	save(numberSimple,file=paste(path,"numberSimple_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
	
	
	#calculate big N for PPV calculation
	Num<-vector(length=Nu)
	for (i in 1:Nu)
		{Num[i]<-5500-sum(rr[i,]==1)
		}
	Num<-2*Num
	TP<-correct
	FP<-tooMany
	FN<-50-TP
	TN<-Num - (FP+TP+FN)

	ACC<-(TP+TN)/Num
	NPV<-TN/(TN+FN)
	PPV<-TP/(TP+FP)
	quantError<-sumFrzl/(1/correct*sumBeta*(correct+tooMany))


}


## adjusted postprocessing for ground truth comparison 
runPostProc<-function(Nu,SNR,thresh,width,quant,g,path,threshCounts=0,mz.bin=mz.bins, chargestates=c(2,3,4,5),recalc=FALSE){
load(paste(path,"resultList_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
load(paste(path,"lengthResultList_",thresh,"_",SNR,"_",width*1000,".RDA",sep=""))
inCorrectList<-list()
correct<-vector(length=Nu)
tooMany<-vector(length=Nu)
errsRss.tp<-vector(length=Nu)
sumFrzl<-vector(length=Nu)
sumBeta<-vector(length=Nu)
pp_resultList<-matrix(nrow=0,ncol=4)
pp_lengthResultList<-vector(length=Nu)
charges<-chargestates

##recalc the breakpoints
if(recalc)
{breakCountMatrix<-matrix(ncol=max(chargestates),nrow=length(mz.bin)+1)
	 for (i in charges)
		{breakCountMatrix[,i]<-compareSwissprot(i,mz.bin)
		}
	save(breakCountMatrix,file=paste(path,"/breakCountMatrix.RDA",sep=""))
}
else
{	load(paste(path,"/breakCountMatrix.RDA",sep=""))
}

if(chargestates[1]==2)
{
load("uniprot_sprot-HUMAN-tryptic-equispaced11-500-700-charges-2-5-N-500-k-20.rda")
load(paste("uniprot_sprot-HUMAN-tryptic-equispaced11-500-700-charges-2-5-N-500-k-20-spectra-SNR-",SNR,".rda",sep=""))
}
else
{
load("uniprot_sprot-HUMAN-tryptic-equispaced11-500-700-charge-1-N-500-k-20.rda")
load(paste("uniprot_sprot-HUMAN-tryptic-equispaced11-500-700-charge-1-N-500-k-20-spectra-SNR-",SNR,".rda",sep=""))
}

for(i in 1:Nu)
{
      resultListSample<-resultList[max((sum(lengthResultList[min(i-1,1):(i-1)])+1),1):sum(lengthResultList[1:i]),]
      resultListSample<-resultListSample[resultListSample[,1]>0,]
      for (k in chargestates)
	{ resultListSampleCharge<-resultListSample[resultListSample[,2]==k,,drop=F]
	  otherResults<-resultListSample[resultListSample[,2]!=k,]
         resultListSample<- rbind(resultListSampleCharge[breakCountMatrix[resultListSampleCharge[,1],k]>threshCounts, ],otherResults)
       }

       result<-resultListSample
       result<-ams.pp.pl.slidingMaxAdjusted(result,FALSE,g)
       result<-result[result[,1]>0,]
       xCombined<-NULL
	for(j in 1:length(result[,1]))
          {
    		if(result[j,4]>.5)
			{model<-buildAveragineModelShort(mz.bin[result[j,1]],mz.bin, result[j,2],S="Y")
		         xNew<-Re(fft(model[[1]],inverse=TRUE))
	     		  xNew<-c(xNew[max((model[[2]]-result[j,1]),0):length(xNew)],rep(0,max(0,(model[[2]]-result[j,1]))))
			}
		else	{model<-buildAveragineModelShort(mz.bin[result[j,1]],mz.bin, result[j,2],S="N")
		        xNew<-Re(fft(model[[1]],inverse=TRUE))
	   		 xNew<-c(xNew[max((model[[2]]-result[j,1]),0):length(xNew)],rep(0,max(0,(model[[2]]-result[j,1]))))
			}

             xCombined<-cbind(xCombined,xNew)
	  }
	print(dim(xCombined))
	print(length(N$S[i,]))
      
       
       xCombined<-xCombined[,result[,3]>.Machine$double.eps]



      #obtaining ground Truth
       breaks<-ams.pp.bins2breaks(mz.bin)
	m0<-findInterval(samples$info[5][((i-1)*20+1):(i*20),1],breaks)
	zInfo<-samples$info[6][((i-1)*20+1):(i*20),1]
	intensity<-samples$info[7][((i-1)*20+1):(i*20),1]
	groundTruth<-matrix(0,nrow=20,ncol=3)
	#Calculating tpr and fpr
	for(j in 1:20)
	{groundTruth[j,]<-cbind(m0[j],zInfo[j],intensity[j])
	}
	print(groundTruth)
	est.TPs.idx<-matrix(0,nrow=0,ncol=3)
	idfyerSet<-NULL
	for (k in 1:20)

      {
          if (sum(cbind(groundTruth[k,1],groundTruth[k,2]) %in% result[,1:2])==2)
            {correct[i]<-correct[i]+1
            idfyer<-which(   (result[,1]==groundTruth[k,1]) & (result[,2]==groundTruth[k,2]) )
            est.TPs.idx<-rbind(est.TPs.idx,cbind(result[idfyer,1],result[idfyer,2],result[idfyer,3]))
            idfyerSet<-cbind(idfyerSet,idfyer)
            }
          else
           {inCorrectList<-list(inCorrectList, groundTruth[k,], i)
           }
     }

     falseResult<-result[-idfyerSet,]
     
     print(falseResult)
     if(length(falseResult)==4)
	{tooMany[i]<-1
	}
     else{
         tooMany[i]<-length(falseResult[,1])
	 }
     #beta gewurschtel quantitativ
     beta <- NULL;
     for (n in 1:length(est.TPs.idx[,1])) {
     # find corresponding peak in sample set
        c.idx <- which(groundTruth[,1] == est.TPs.idx[n,1]);
        true.beta <- sum(groundTruth[c.idx,3]); # guard against multiple peaks
        beta <- rbind(beta, c(est.TPs.idx[n,3], true.beta))
      }
      betasum <- apply(beta,2,sum);
      errsRss.tp [i]<- sum((beta[,1]/betasum[1] - beta[,2]/betasum[2])^2);
      # linus
      frzl <- rbind(beta, cbind(result[!(result[,1] %in% est.TPs.idx[,1]),3] ,rep(0,sum(!(result[,1] %in% est.TPs.idx[,1])))))#tooMany[i])));
      #print(frzl)
      frzl <- t(t(frzl)/apply(frzl,2,sum));
      errsRss.tp[i]<-(sum((frzl[,1]-frzl[,2])^2) / (1/correct[i]*errsRss.tp[i]*(length(result[,1]))))-1#ncol(pq.truth))) -1
      sumFrzl[i]<-sum((frzl[,1]-frzl[,2])^2)
      sumBeta[i]<-sum((beta[,1]/betasum[1] - beta[,2]/betasum[2])^2);
      
      pp_resultList<-rbind(pp_resultList,result)
      pp_lengthResultList[i]<-length(result)/4	
    }

save(correct,file=paste(path,"pp_correct_",thresh,"_",g,"_",quant,"_",SNR,"_",width*1000,".RDA",sep=""))
save(tooMany,file=paste(path,"pp_tooMany_",thresh,"_",g,"_",quant,"_",SNR,"_",width*1000,".RDA",sep=""))
save(inCorrectList,file=paste(path,"pp_inCorrectList_",thresh,"_",g,"_",quant,"_",SNR,"_",width*1000,".RDA",sep=""))
save(pp_resultList,file=paste(path,"pp_resultList_",thresh,"_",g,"_",quant,"_",SNR,"_",width*1000,".RDA",sep=""))
save(pp_lengthResultList,file=paste(path,"pp_lengthResultList_",thresh,"_",g,"_",quant,"_",SNR,"_",width*1000,".RDA",sep=""))
save(errsRss.tp,file=paste(path,"pp_errs_",thresh,"_",g,"_",quant,"_",SNR,"_",width*1000,".RDA",sep=""))

}




# now run simulation

runSim(100,500,0,.0001,"/results/",c(1),1e-26,EFA=FALSE,hierarchical=FALSE,gdf=TRUE,bic.steps=0,maxRangeSize=10)
runSim(50,500,0,.0001,"/results/",c(1),1e-26,EFA=FALSE,hierarchical=FALSE,gdf=TRUE,bic.steps=0,maxRangeSize=10)
runSim(25,500,0,.0001,"/results/",c(1),1e-26,EFA=FALSE,hierarchical=FALSE,gdf=TRUE,bic.steps=0,maxRangeSize=10)
runSim(10,500,0,.0001,"/results/",c(1),1e-26,EFA=FALSE,hierarchical=FALSE,gdf=TRUE,bic.steps=0,maxRangeSize=10)
runSim(5,500,0,.0001,"/results/",c(1),1e-26,EFA=FALSE,hierarchical=FALSE,gdf=TRUE,bic.steps=0,maxRangeSize=10)


runPostProc(500,100,0,.0001,0,3,"/results/",0,mz.bin=mz.bins, chargestates=c(1),recalc=TRUE)
runPostProc(500,50,0,.0001,0,3,"/results/",0,mz.bin=mz.bins, chargestates=c(1),recalc=FALSE)
runPostProc(500,25,0,.0001,0,3,"/results/",0,mz.bin=mz.bins, chargestates=c(1),recalc=FALSE)
runPostProc(500,10,0,.0001,0,3,"/results/",0,mz.bin=mz.bins, chargestates=c(1),recalc=FALSE)
runPostProc(500,5,0,.0001,0,3,"/results/",0,mz.bin=mz.bins, chargestates=c(1),recalc=FALSE)

ams.pp.runHierarchical<-function(data,bins,charges,thresholdBetaHat=0,thresholdR2, limit,width,EFA=EFA,gdf=FALSE,bic.steps=0,maxRangeSize=10)
     {print("started running Simple Peak Detection")
      resultSingle<-ams.pp.runSingleRegression(data=data, bins=bins, charges=charges, thresholdBetaHat=thresholdBetaHat,thresholdR2=thresholdR2,width=width)
      nextN<-1
      flaggedAreas<-as.matrix(resultSingle[[3]])
      order<-order(flaggedAreas[,2])
      flaggedAreas<-cbind(rep(0,length(order)),flaggedAreas[order,])
      lengthFlaggedAreasOld<-0
      while(length(flaggedAreas)!=lengthFlaggedAreasOld)
        {lengthFlaggedAreasOld<-length(flaggedAreas)
         flaggedAreas<-joinAdjacent(flaggedAreas)
        }
       flaggedAreas<-flaggedAreas[,2:4] 
 #filter out those flaggedAreas which have been already explained by simple regression
	solvedAreas<-as.matrix(resultSingle[[2]][,4:5])
if(length(solvedAreas)==2)
{solvedAreas<-matrix(solvedAreas,nrow=1,ncol=2)
}
if(length(solvedAreas)>0)
{
 for (i in 1:nrow(solvedAreas))
	{ for (j in 1: nrow(flaggedAreas))
		{
		 if((solvedAreas[i,1]>=flaggedAreas[j,1])&(solvedAreas[i,1]<=flaggedAreas[j,2]))
      {
			 oldEnd<-flaggedAreas[j,2]
			 flaggedAreas[j,2]<-solvedAreas[i,1]-1
			 if(oldEnd>solvedAreas[i,2])
				{rbind(flaggedAreas,c(solvedAreas[i,2]+1,oldEnd,flaggedAreas[j,3]))
				}
			}
		if((solvedAreas[i,2]>=flaggedAreas[j,1])&(solvedAreas[i,2]<=flaggedAreas[j,2]))
			{
			 flaggedAreas[j,1]<-solvedAreas[i,2]+1

			}
		}
	}

}
#remove only one elemental flagged areas
flaggedAreas<-flaggedAreas[flaggedAreas[,1]!=flaggedAreas[,2],]


print("started running Multiple Peak Detection")

      resultMult<-matrix(nrow=0,ncol=4)
      for (k in 1:(length(flaggedAreas[,1])))
             {    kong<-ams.pp.buildModelMatrix(flaggedAreas[k,1],flaggedAreas[k,2],100,data=data,EFA=EFA,maxRangeSize=maxRangeSize,charge=charges,width=width,limit=limit)
                  fooResult<-predict.ams.pp.strap.model(kong,EFA=EFA,data=data,includingZero=TRUE,gdf=gdf,bic.steps=bic.steps)
                  fight<-ams.pp.listPeaks(fooResult,kong$iCollection)
                  resultMult=rbind(resultMult,fight)

             }

      #join result with Result from Single
      final<-rbind(resultMult,resultSingle[[2]][,c(1:3,7)])
            return(final)
     }

"ams.pp.bins2breaks" <-
function(bins) 
{
	# returns the n+1 breaks enclosing n bins
	n <- length(bins);
	return(
		c(
		bins[1]-0.5*diff(bins[1:2]), 
		bins[1:(n-1)]+0.5*diff(bins), 
		bins[n]+0.5*diff(bins[(n-1):n])
		)
	);
}

"ams.pp.pl.slidingMax" <-
function(peaks, charge.state.wise=F, n=3)
{
	discardPeaks <- function(p, n)
	{
		keep <- NULL;
		current.row <- 1;
		while(current.row <= nrow(p)) {
			# p is sorted; so it suffices to look
			# (n-1)/2 bins ahead 
			neighborhood <- which( 
				p[current.row:nrow(p),2] 
				<= p[current.row,2]+(n-1)/2 
			) + current.row -1;
			# find max
			is.max <- which.max(p[neighborhood, 6]);
			keep <- c(keep, neighborhood[is.max]);
			current.row <- max(neighborhood)+1;
		}
		return(p[keep,,drop=F]);
	}

	# make sure peak list is sorted by mass
	if (is.unsorted(peaks[,1])) {
		peaks <- peaks[sort(peaks[,1], index.return=T)$ix,,drop=F];
	}

	if (charge.state.wise) {
		# split data charge state wise
		ret <- NULL;
		for (i in sort(unique(peaks[,5]))) {
			ret <- rbind(ret, discardPeaks(peaks[peaks[,5]==i,,drop=F], n));
		}
		# re-sort by mass
		ret <- ret[sort(ret[,1], index.return=T)$ix,,drop=F];
	} else {
		ret <- discardPeaks(peaks, n)
	}
	return(ret);
}

ams.pp.getRegions.MeanFilter<-function (spectrum, mz.nIntervals, mz.neighborhood, noise.threshold.factor)
{
    embedding <- embed(c(rep(0, (mz.neighborhood - 1)/2), spectrum[,
        2], rep(0, (mz.neighborhood - 1)/2)), mz.neighborhood)
    if(dim(embedding)[1]<dim(spectrum)[1])
      {embedding<-rbind(embedding,matrix(0,nrow=(dim(spectrum)[1]-dim(embedding)[1]),ncol=dim(embedding)[2]))
      }
    means <- apply(embedding, 1, mean,na.rm=TRUE)
    region.labels <- cut(spectrum[, 1], mz.nIntervals, labels = F)
    relevantRegions <- NULL
    for (i in 1:mz.nIntervals) {
        tmp.means <- means[region.labels == i]
        noise.mean <- min(tmp.means,na.rm=TRUE)
        relevantRegions <- c(relevantRegions, !(tmp.means > (noise.mean *
            noise.threshold.factor)))
    }
    return(relevantRegions)
}

runPostProc<-function(width,quant,g,pathIn,pathOut,mz.bin=mz.bins, chargestates=c(1,2,3,4,5,6),database=FALSE,recalc=FALSE,databasePath=NULL,threshCounts=0,linear=TRUE){
load(pathIn)
pp_resultList<-matrix(nrow=0,ncol=4)
charges<-chargestates
#source("~/projects/sulveragine/ams.pp.slidingMaxAdjustedSul.R")
##recalc the breakpoints
result<-ams.pp.pl.slidingMaxAdjusted(resultList,FALSE,g)

##if database comparison wanted
if(database)
{
##recalc the breakpoints
if(recalc)
{breakCountMatrix<-matrix(ncol=max(chargestates),nrow=length(mz.bin)+1)
 for (i in charges)
 {breakCountMatrix[,i]<-compareSwissprot(i,mz.bin,databasePath)
 }
 save(breakCountMatrix,file=paste(path,"/breakCountMatrix.RDA",sep=""))
}
else
{load(paste(path,"/breakCountMatrix.RDA",sep=""))
}
resultListSample<-NULL
for (k in chargestates)
{resultListSampleCharge<-result[result[,2]==k,,drop=F]
 resultListSample<- rbind(resultListSampleCharge[breakCountMatrix[resultListSampleCharge[,1],k]>threshCounts, ],resultListSample)
}
result<-resultListSample
}	 
#print(result)
result<-result[result[,1]>0,]
#print(i)
   
  
xCombined<-NULL
for(j in 1:length(result[,1]))
{
 if(result[j,4]>.5)
 {model<-buildAveragineModelShort(mz.bin[result[j,1]],mz.bin, result[j,2],S="Y",width=width)#,linear=linear)
  xNew<-Re(fft(model[[1]],inverse=TRUE))
  xNew<-c(xNew[max((model[[2]]-result[j,1]),0):length(xNew)],rep(0,max(0,(model[[2]]-result[j,1]))))
 }
 else
  {model<-buildAveragineModelShort(mz.bin[result[j,1]],mz.bin, result[j,2],S="N",width=width)
   xNew<-Re(fft(model[[1]],inverse=TRUE))
	 xNew<-c(xNew[max((model[[2]]-result[j,1]),0):length(xNew)],rep(0,max(0,(model[[2]]-result[j,1]))))#,linear=linear)
	}
 xCombined<-cbind(xCombined,xNew)
}
print(dim(xCombined))
result[,3]<-try(nnls.fit(xCombined[1:length(mz.bin),],N$S[i,]),silent=TRUE)
 
    
 xCombined<-xCombined[,result[,3]>.Machine$double.eps]
 result<-result[result[,3]>.Machine$double.eps,]
 pp_resultList<-result
 save(xCombined,file=paste(pathOut,"xCombined_","_",g,"_",width*1000,".RDA",sep=""))
save(pp_resultList,file=paste(pathOut,"pp_resultList_","_",g,"_",width*1000,".RDA",sep=""))
}



postProc<-function(result){
chargeOrd<-order(result[,2],result[,1])
result<-result[chargeOrd,]
#get rid of similar charge states next to each other, only using max
ppResult<-matrix(0,nrow=length(result)/3,ncol=3)
 nextN<-1
     for (i in 2:(length(result)/3)){
         if (( (result[i,1]-1==result[i-1,1]) && (result[i,2]==result[i-1,2])) |( (i>=3) && (result[i,1]-1==result[i-2,1]) && (result[i,2]==result[i-2,2]))){
           ppResult[nextN,]<-(result[i,3]>=ppResult[nextN,3])*result[i,]+(result[i,3]<ppResult[nextN,3])*ppResult[nextN,]
           }
          else{
            nextN<-nextN+1
            ppResult[nextN,]<-result[i,]
          }
        }
if(ppResult[1,1]<=0){
      ppResult<-ppResult[2:nextN,]
      nextN<-nextN-1
    }
else{
     ppResult<-ppResult[1:nextN,]
    }
#get rid of peaks at same position for two different charge states
positionOrd<-order(ppResult[,1])
ppResult<-ppResult[positionOrd,]
if(ppResult[1,1]<=0){
      ppResult<-ppResult[2:nextN,]
    }

nextN<-1
for (j in 2:(length(ppResult)/3))
{ if(ppResult[j,1]==ppResult[nextN,1]){
    ppResult[nextN,]<-(ppResult[j,3]>=ppResult[nextN,3])*ppResult[j,]+(ppResult[j,3]<ppResult[nextN,3])*ppResult[nextN,]
    #print(cbind(ppResult[j,1],nextN,ppResult[nextN,1]))
  }
  else{
     nextN<-nextN+1
     ppResult[nextN,]<-ppResult[j,]
  }
}
return(ppResult[1:nextN,])
}




compareSwissprot<-function(chargestate,bins,databasePath)
{
breaks<-ams.pp.bins2breaks(bins)
load(databasePath)
monoMass<-vector(length=length(db$H))
for (i in 1:length(db$H))
{
 monoMass[i]<-ams.mercury.mercury(c(db$H[i],db$C[i],db$N[i],db$O[i],db$S[i]),chargestate,1e-26)[1,1]
}

monoBins<-findInterval(monoMass,breaks)

breakCount<-vector(length=length(breaks))
for(j in 1:length(breaks))
{breakCount[j]<-sum(monoBins==j)
}

return(breakCount)
}

	
exactAveragine<-function(mass)
    {numberAvs<-mass/111.125
     numberHs<-7.7583*numberAvs
     numberCs<-4.9384*numberAvs
     numberNs<-1.3577*numberAvs
     numberOs<-1.4773*numberAvs
     numberSs<-0.0417*numberAvs
     return(c(numberHs,numberCs, numberNs, numberOs,numberSs))
    }
lightAveragine<-function(mass)
    {numberAvs<-mass/109.7878
     numberHs<-7.7583*numberAvs
     numberCs<-4.9384*numberAvs
     numberNs<-1.3577*numberAvs
     numberOs<-1.4773*numberAvs
     return(c(numberHs,numberCs, numberNs, numberOs,0))
    }
sulveragine<-function(mass)
    {numberAvs<-mass/417.5719
     numberHs<-27*numberAvs
     numberCs<-13*numberAvs
     numberNs<-3*numberAvs
     numberOs<-6*numberAvs
     numberSs<-3*numberAvs
     nonSul<-lightAveragine(mass)
     result<-(6*nonSul+c(numberHs,numberCs, numberNs, numberOs,numberSs))/7
     return(result)
    }





# calculates pdf for remaining fractional part of atom abundance (so abundance-floor(abundance))
# molecule is either S, C ,H, N, or O
# exactness is given as the inverse of the required exactness
# correction indicates whether a pdf should be produced (so corrected for area  under curve=1


# builds fractional binomial distribution by building a hierarchical model of 2 binomial distribution with amount being
# the probability to decide for either one
# only for amount in (0,1)
getDistributionHBin<-function(molecule,amount, charge)
    {  if((amount<0)|(amount>1))
          {print("fractional binomial is only defined for amount in (0,1)")
           return()
          }
       if (molecule=="H")
                {S1<-matrix(c(1.0078246,	2.0141021,0.99985,	0.00015),nrow=2,ncol=2)} # H
       if (molecule=="C")
                {S1<-matrix(c(12.0000000, 	13.0033554,0.988930,	0.011070 ),nrow=2,ncol=2)} # C
       if (molecule=="N")
                {S1<-matrix(c(14.0030732, 	15.0001088,0.996337,	0.003663 ),nrow=2,ncol=2)} # N
       if (molecule=="O")
                {S1<-matrix(c(15.9949141, 	16.9991322, 	17.9991616,0.997590,	0.000374,	0.002036 ),nrow=3,ncol=2)} # O
       if (molecule=="S")
                {S1<-matrix(c(31.972070, 	32.971456, 	33.967866, 	34,	35.967080,0.9502,	0.0075,		0.0421, 0,	0.0002 ),nrow=5,ncol=2)} # S
       S1[,1]<-S1[,1]/charge         
       S1new<-S1
       S1new[1,1]<-S1[1,1]*amount           #correcting the mass
       S1new[,1]<-S1[,1]-S1[1,1]+S1new[1,1]
       S0<-S1new                            #distribution for no atom
       S0[,2]<-0
       S0[1,2]<-1                           #all mass at zero
       Snew<-S1new                          #return object
       Snew[,2]<-amount*S1new[,2]+(1-amount)*S0[,2]
       if (molecule=="S")                   #exclude p()=0
          {Snew<-Snew[c(1,2,3,5),]
          }
       return(Snew)
    }

#adapts scale of a data set to match requirements of exactntess
#Funktion funktioniert noch nicht fuer den Fall hdistr, also wenn
#nicht 0er eingefuegt werden muessen, sondern vielmehr Daten ausgesucht


fftDiscrete<-function(distr1, distr2,limit=1e-26)
     {kmax<-length(distr1[,1])+length(distr2[,1])
      distrNew<-matrix(0,nrow=kmax,ncol=2)
      for (k in 2:kmax)
        {for (i in 1:min((k-1),length(distr1[,1])))
            {if (  ((k-i)>=0)  &&  ((k-i)<=length(distr2[,1])))
                {distrNew[k,2]=distrNew[k,2]+distr1[i,2]*distr2[(k-i),2]
                 distrNew[k,1]=distrNew[k,1]+distr1[i,2]*distr2[(k-i),2]*(distr1[i,1]+distr2[(k-i),1])
               }
            }
         }
      distrNew<-distrNew[distrNew[,2]>0,]   
      distrNew[,1]<-distrNew[,1]/distrNew[,2]
      distrNew<-distrNew[distrNew[,2]>limit,]
      return(distrNew)
     }

#function that builds an exact averagine model by convoluting
#mercury result for next lowest integer model and the continuous binomials
#for each element

buildAveragineModelShort<-function(mass, masses, charge, limit=1e-26,width=.00005,S="Ave") #width needs to be set visually
  {stopifnot(require(amsmercury))

       if (S=="Ave")
         {
          stoich<-exactAveragine(mass*1.000641*charge)
         }
        if (S=="Y")
          {
            stoich<-sulveragine(mass*1.000641*charge)
          }
        if (S=="N")
          {
            stoich<-lightAveragine(mass*1.000641*charge)
          }
	basic<-ams.mercury.mercury(stoich, charge, limit)
  hdistr<-getDistributionHBin("H",(stoich[1]-floor(stoich[1])),charge)
	cdistr<-getDistributionHBin("C",(stoich[2]-floor(stoich[2])),charge)
	ndistr<-getDistributionHBin("N",(stoich[3]-floor(stoich[3])),charge)
	odistr<-getDistributionHBin("O",(stoich[4]-floor(stoich[4])),charge)
	sdistr<-getDistributionHBin("S",(stoich[5]-floor(stoich[5])),charge)



      result<-fftDiscrete(hdistr,cdistr,limit)
      result<-fftDiscrete(result,ndistr,limit)
      result<-fftDiscrete(result,odistr,limit)
      result<-fftDiscrete(result,sdistr,limit)
      result<-fftDiscrete(basic,result,limit)

     masses<-ams.pp.bins2breaks(masses)
      sig <- rep(0, length(masses))
      position<-vector(length=length(result[,1]))
      position<-findInterval(result[,1],masses)
      for (i in 1:length(result[,1]))
          {sig[position[i]]<-sig[position[i]]+result[i,2]
          }
      minPosition<-min(position)

 lpf<-vector(length=length(masses))
 lastResult<-1
 i<-floor(length(masses)/2)
 lastResult<-1
 lpf[1]<-lastResult
 change<-1
 lpfi<-dnorm(masses[i],masses[i],width*masses[i])
 while((lastResult>limit)&(change<i))
 {lpf[length(lpf)+1-change]<-dnorm(masses[i-change],masses[i],width*masses[i])/lpfi
  lpf[1+change]<-dnorm(masses[i+change],masses[i],width*masses[i])/lpfi
  lastResult<-min(lpf[1+change],lpf[length(lpf)+1-change])
  change<-change+1
 }
res<-fft(sig)*fft(lpf)/length(lpf)
return(list(res,minPosition))
  }




findMaxPeakAndPosition<-function(data)
   {       maxValue<-max(data[,2])
           position<-max(c(1:length(data[,2]))[data[,2]==maxValue])
           return(cbind(maxValue,position))
   }
   
findMaxPeakAndPositionUns<-function(data, unsolved)
   {
           maxValue<-max(data[unsolved,2])
           position<-max(unsolved[data[unsolved,2]==maxValue])
           return(cbind(maxValue,position))
   }   
   
joinAdjacent<-function(bins)
  {binsNew<-bins   #copy current binning structure
   nextN<-1
   for (i in 1:(length(bins[,1])-1))  #for all bins
    {if ((binsNew[nextN,1]==0&bins[i+1,1]==0)&(binsNew[nextN,3]>=(bins[i+1,2])-1))   #if 2 adjacent are both 0
        {    
         binsNew[nextN,3]<-bins[i+1,3]
         if(binsNew[nextN,2]>bins[i+1,2])
           {binsNew[nextN,2]<-bins[i+1,2]
           }
        }
      else{ #otherwise no change taking place
         nextN<-nextN+1
         binsNew[nextN,]<-bins[i+1,]
        }
     } #return new Bins
   return(binsNew[1:nextN,])
   }
   

 ams.pp.listPeaks<-function(beta,iCollection)
 {
  lengthSolution<-sum(beta>0)
  active<-which(beta>0)
  position<-vector(length=lengthSolution)
  charge<-vector(length=lengthSolution)
  sulfInd<-vector(length=lengthSolution)
  value<-beta[beta>0]
  charge<-iCollection[active,2]
  sulfInd<-iCollection[active,3]
  position<-iCollection[active,1]-iCollection[active,5]+iCollection[active,4]
  return(cbind(as.vector(position),as.vector(charge),as.vector(value),as.vector(sulfInd)))
 }

"nnls.fit" <-
function(x,y,wsqrt=1,eps=0,rank.tol=1e-07) {
  ## Purpose: Nonnegative Least Squares (similar to the S-Plus function
  ## with the same name) with the help of the R-library quadprog

 ## ------------------------------------------------------------------------
  ## Attention:
  ## - weights are square roots of usual weights
  ## - the constraint is coefficient>=eps

 ## ------------------------------------------------------------------------
  ## Author: Marcel Wolbers, July 99
  ##
#========================================================================
  require ("quadprog")
  m <- NCOL(x)
  if (length(eps)==1) eps <- rep(eps,m)
  x <- x * wsqrt
  y <- y * wsqrt
  #sometimes a rescaling of x and y helps (if solve.QP.compact fails otherwise)
  xscale <- apply(abs(x),2,mean)
  yscale <- mean(abs(y))
  x <- t(t(x)/xscale)
  y <- y/yscale
  Rinv <- backsolve(qr.R(qr(x)),diag(m))
  cf <- solve.QP.compact(Dmat=Rinv,dvec=t(x)%*%y,Amat=rbind(rep(1,m)),
                   Aind=rbind(rep(1,m),1:m),bvec=eps*xscale/yscale,
                         factorized=TRUE)$sol
  cf <- cf*yscale/xscale  #scale back
  cf
}

predict.ams.pp.strap.model<-function(model,EFA=TRUE,data,bic.steps=0,gdf=TRUE,includingZero=FALSE)
{   xCombined<-model$xCombined
    if(!is.null(xCombined))
    {
     beginWithOffset<-model$beginWithOffset
     endWithOffset<-model$endWithOffset
     preselection<-model$preselection
    
     larsResult<-NULL
     larsResult$beta<-NULL
     if(length(preselection)==0)
       { larsResult$beta<-0
       }
     else
       {
         larsResult<-ams.pp.strap.lars(xCombined,data[beginWithOffset:endWithOffset,2], EFA=EFA,preselection=preselection,bic.steps=bic.steps,gdf=gdf,ignores=ignores,includingZero=includingZero)
       }
     if(is.null(larsResult)||is.null(larsResult$beta)|| !is.finite(larsResult$beta) ||(sum(larsResult$beta)==0))
       { xlassoTotal<-NULL
          nnls<-NULL
          beta<-NULL
       }
     else
       { xlassoTotal<-c(1:dim(xCombined)[2])[larsResult$beta>0]
         nnls<-nnls.fit(as.matrix(xCombined[,xlassoTotal]),data[beginWithOffset:endWithOffset,2])
         beta<-rep(0,dim(xCombined)[2])
         beta[xlassoTotal]<-nnls
       }
     }
     else
     {
      beta<-vector(length=0)
     }   
     return(beta)
}

ams.pp.runSingleRegression<-function(data,bins,charges=c(2,3,4,5),thresholdR2,width=0.0001,sulLevels=3,thresholdBetaHat=NULL)
{ flaggedLower<-list()
	flaggedUpper<-list()
	flaggedOff<-list()
 	resultSinglePos<-list()
	resultSingleInt<-list()
	resultSingleCha<-list()
	resultSingleLower<-list()
	resultSingleUpper<-list()
	resultSingleMax<-list()
	resultSingleS<-list()
	for (i in 1:(length(bins[,1])))
          {if (bins[i,1]==0)
             {  	if(is.null(thresholdBetaHat))
                  	{
                  	   thresholdBetaHat<-median(data[bins[i,2]:bins[i,3],2])
                  	}

                distance<-bins[i,3]-bins[i,2]+1
                exactness<-1/((width)/distance)#1/((width/charge)/distance)
                dataBin<-data[bins[i,2]:bins[i,3],2]
                comb<-2*length(charges)
                fftModel<-matrix(ncol=comb,nrow=length(data[bins[i,2]:bins[i,3],1]))
                fftModelPart2<-matrix(ncol=comb,nrow=1)
                filterRes<-matrix(ncol=comb,nrow=length(data[bins[i,2]:bins[i,3],1]))
                resThreshold<-matrix(ncol=comb,nrow=length(data[bins[i,2]:bins[i,3],1]))
                for(j in 1:length(charges))
                   {fftModel[,2*j]<-buildAveragineModelShort((data[bins[i,2],1]+data[bins[i,3],1])/2,data[bins[i,2]:bins[i,3],1],charges[j],width=width,S="Y")[[1]][1:length(data[bins[i,2]:bins[i,3],1])]
             		    fftModel[,2*j-1]<-buildAveragineModelShort((data[bins[i,2],1]+data[bins[i,3],1])/2,data[bins[i,2]:bins[i,3],1],charges[j],width=width,S="N")[[1]][1:length(data[bins[i,2]:bins[i,3],1])]
                   }
                dataBin<-t(cbind(t(dataBin),t(rep(0,max(length(fftModel[,1])-length(dataBin),0)))))

                for(j in 1:comb)
                   {filterRes[,j]<-fft(dataBin)*fftModel[,j]
                    resThreshold[,j]<-Re(fft(filterRes[,j],inverse=T))
                   }

                unsolved<-c(1:(length(resThreshold[,1])))

    	 	         resultsr<-"none"
                while (resultsr!="small"&!is.null(unsolved)&(length(unsolved)>1))
                          { maxVec<-apply(resThreshold[unsolved,],2,max)
			    maxValue<-max(resThreshold[unsolved,])
			    combVec<-c(1:comb)
			    SInd<-2-min(combVec[maxVec==maxValue])%%2
			    S<-"stop"
			if(SInd==1)
			    {S<-"N"
			     }
			if(SInd==2)
			    {S<-"Y"
			     }
	        maxCharge<-ceiling(min(combVec[maxVec==maxValue])/2)+min(charges)-1
	        maxChargePos<-(min(combVec[maxVec==maxValue]))
			    posCharge<-which(combVec==maxChargePos)

			    filteredSignal<-resThreshold[,posCharge]
          maxXPeak<-findMaxPeakAndPositionUns(cbind(c(1:(length(resThreshold[,1]))),data[bins[i,2]:bins[i,3],2]),unsolved)

          xMovedGeneral<-buildAveragineModelShort(data[bins[i,2]+maxXPeak[2]-1,1],data[bins[i,2]:bins[i,3],1],maxCharge,width=width,S=S)
			    xMoved<-Re(fft(xMovedGeneral[[1]],inverse=T))
			    maxPeak<-findMaxPeakAndPosition(cbind(c(1:(length(xMoved))),xMoved))
          xRot<-t(cbind(t(xMoved[min((maxPeak[2]+1),(length(xMoved))):(length(xMoved))]),t(xMoved[0:(maxPeak[2])])))
          offset<-max(2*max(c(1:(length(xRot)/2))[xRot[1:(length(xRot)/2)]>.1*maxPeak[1]])+2,2)

			    if((maxPeak[2]+offset>length(xMoved))||(maxPeak[2]-offset<1))
			     { 	if ((maxPeak[2]+offset>length(xMoved))&&(maxPeak[2]-offset<1))
 					{x<-c(rep(0,offset-maxPeak[2]+1),xMoved,rep(0,offset+maxPeak[2]-length(xMoved)))
					}
 				 else{if (maxPeak[2]-offset<1)
 					{x<-c(rep(0,offset-maxPeak[2]+1),xMoved[1:(maxPeak[2]+offset)])
					}
				     if (maxPeak[2]+offset>length(xMoved))
 					{x<-c(xMoved[(maxPeak[2]-offset):length(xMoved)],rep(0,offset+maxPeak[2]-length(xMoved)))
					}
				    }
			     }
			     else
 			      {
 			        x<-xMoved[(maxPeak[2]-offset):(maxPeak[2]+offset)]
			      }
			    if((bins[i,2]+maxXPeak[2]-offset-1<1)||(bins[i,2]+maxXPeak[2]+offset-1>length(data[,2])))
			     {
				if (bins[i,2]+maxXPeak[2]-offset-1<1)
 				 	{ y<-c(rep(0,-bins[i,2]-maxXPeak[2]+offset+2),data[max(bins[i,2]+maxXPeak[2]-offset-1,1):min(bins[i,2]+maxXPeak[2]+offset-1,length(data[,2])),2])
 					}
 			        if (bins[i,2]+maxXPeak[2]+offset>length(data[,2]))
 					{y<-c(data[max(bins[i,2]+maxXPeak[2]-offset,1):min(bins[i,2]+maxXPeak[2]+offset-1,length(data[,2])),2],rep(0,bins[i,2]+maxXPeak[2]+offset-length(data[,2])))
					}
			     }
			     else
 			      {
   				     y<-data[max(bins[i,2]+maxXPeak[2]-offset-1,1):min(bins[i,2]+maxXPeak[2]+offset-1,length(data[,2])),2]
 			      }
      regress<-lm(y~0+x)
      if(regress$coefficients[1]>thresholdBetaHat)
       {expMax<-maxXPeak[2]
    		lower<-expMax-(offset/2)
      			while(!(lower %in% unsolved) & (lower< expMax))
           				{lower<-lower+1
           				}
         			upper<-expMax+(offset/2)
        			while(!(upper %in% unsolved) & upper> expMax)
           				{upper<-upper-1
           				}
            unsolved<-unsolved[!unsolved %in% (max(expMax-offset/2,1)):min(expMax+offset/2,length(resThreshold[,1]))]

        			if(lower==upper)
          			{lower<-min(unsolved)
           			 upper<-max(unsolved)
           			 unsolved<-NULL
           			}

       			Rsquared<-summary(regress)$r.squared#1-mse/var(y)
       			
       			if(is.na(Rsquared))
     				{  resultsr<-"pos"
         	  }
 	    			
            if(!is.na(Rsquared)&&(Rsquared<thresholdR2))
     				{  resultsr<-"pos"
         			 flaggedLower<-c(flaggedLower,max(bins[i,2],bins[i,2]+maxXPeak[2]-offset/2-1))
				    	 flaggedUpper<-c(flaggedUpper,min(bins[i,3],bins[i,2]+maxXPeak[2]+offset/2-1))
					     flaggedOff<-c(flaggedOff,offset)
 			      }
 	    			else
           {
					  resultsr<-"none"
   					resultSinglePos<-c(resultSinglePos,bins[i,2]+maxXPeak[2]-1-maxPeak[2]+xMovedGeneral[[2]])
	  				resultSingleInt<-c(resultSingleInt,regress$coefficients[1])
		  			resultSingleCha<-c(resultSingleCha,maxCharge)
			  		resultSingleLower<-c(resultSingleLower,max(bins[i,2],bins[i,2]+maxXPeak[2]-offset/2-1))
				  	resultSingleUpper<-c(resultSingleUpper,min(bins[i,3],bins[i,2]+maxXPeak[2]+offset/2-1))
				  	resultSingleMax<-c(resultSingleMax,bins[i,2]+maxXPeak[2]-1)
				  	resultSingleS<-c(resultSingleS,SInd)
				   }
		     }
    		 else
       			{resultsr<-"small"
        		}
		    }
		}
	}

singleResult<-matrix(nrow=length(resultSinglePos),ncol=7)
flagged<-matrix(nrow=length(flaggedLower),ncol=3)

if(nrow(singleResult)>0)
{for (i in 1:length(resultSinglePos))
	{singleResult[i,1]<-resultSinglePos[[i]]
	 singleResult[i,3]<-resultSingleInt[[i]]
	 singleResult[i,2]<-resultSingleCha[[i]]
	 singleResult[i,4]<-resultSingleLower[[i]]
	 singleResult[i,5]<-resultSingleUpper[[i]]
	 singleResult[i,6]<-resultSingleMax[[i]]
	 singleResult[i,7]<-resultSingleS[[i]]
	}
}
if(nrow(flagged)>0)
{for (i in 1:length(flaggedLower))
	{flagged[i,1]<-flaggedLower[[i]]
	 flagged[i,2]<-flaggedUpper[[i]]
	 flagged[i,3]<-flaggedOff[[i]]
	}
}
return(list(0,singleResult,flagged))
}

"ams.pp.strap.lars" <-
function(x, y, type = c("plasso"), trace = FALSE, Gram, 
		eps = .Machine$double.eps,  max.steps, use.Gram = TRUE, EFA=FALSE,
		preselection, bic.steps=5, gdf=FALSE,ignores=NULL,includingZero=FALSE)
{	###### gdf=TRUE uses generalized degrees of freedom, gdf=FALSE uses number of active components for df estimation
	###### bic.steps=0 uses comparison with minimum possible BIC
	stopifnot(require(iwrlars))


	### program automatically centers and standardizes predictors.
	###
	### Original program by Brad Efron September 2001
	### Recoded by Trevor Hastie November 2001
	### Computational efficiency December 22, 2001
	### Bug fixes and singularities February 2003
	### Conversion to R April 2003
	### Copyright Brad Efron and Trevor Hastie
	###
	### Extension for "plasso" by Bernhard Renard, Marc Kirchner, January 2007
	
	call <- match.call()
	type <- match.arg(type)
	TYPE <- switch(type, plasso = "PLASSO")
	if(trace)
		cat(paste(TYPE, "sequence\n"))
	nm <- dim(x)
	n <- nm[1]
	m <- nm[2]
	im <- inactive <- seq(m)
	one <- rep(1, n)
	vn <- dimnames(x)[[2]]	
	### Center x and y, and scale x, and save the means and sds
	meanx <- drop(one %*% x)/n
	x <- scale(x, meanx, FALSE)	# centers x
	normx <- sqrt(drop(one %*% (x^2)))
	nosignal<-normx/sqrt(n) < eps
	ignores<-NULL
	if(any(nosignal)) {
		# ignore variables with too small a variance
		ignores<-c(ignores,im[nosignal])
		inactive<-im[-ignores]
		normx[nosignal]<-eps*sqrt(n)
		if(trace)
			cat("LARS Step 0 :\t", sum(nosignal), "Variables with Variance < \eps; dropped for good\n")	#
	}
	#else ignores <- NULL #singularities; augmented later as well
	names(normx) <- NULL
	x <- scale(x, FALSE, normx)	# scales x
	if(use.Gram & missing(Gram)) {
		if(m > 500 && n < m)
			cat("There are more than 500 variables and n<m;\nYou may wish to restart and set use.Gram=FALSE\n")
		if(trace)
			cat("Computing X'X .....\n")
		Gram <- t(x) %*% x	#Time saving
	}
	mu <- mean(y)
	y <- drop(y - mu)
	Cvec <- drop(t(y) %*% x)
	ssy <- sum(y^2)
	residuals <- y
	if(missing(max.steps))
		max.steps <- 8*min(m, n-1)
	beta <- matrix(0, max.steps + 1, m)	# beta starts at 0
	Gamrat <- NULL
	arc.length <- NULL
	R2 <- 1
	RSS <- ssy
	first.in <- integer(m)
	active <- NULL	# maintains active set
	actions <- as.list(seq(max.steps))	
						# a signed index list to show what comes in and out
	drops <- FALSE	# to do with type=="lasso" or "forward.stagewise"
	Sign <- NULL	# Keeps the sign of the terms in the model
	R <- NULL	###
	k <- 0

	#NN# added Indicator Plasso in while and setting Indicator accordingly
	maxDf <- min(m-length(ignores), n-1)
	if (type=="plasso"){
		maxDf <- maxDf - 1; # skip last step for positive LASSO
	}

f<-try(ssq.beta <- nnls.fit(x[,preselection,drop=F], y),silent=TRUE)

if(class(f)=="try-error") 
{noisefactor=0
 while(class(f)=="try-error"&noisefactor<100) 
    {noise <- 1e8*noisefactor*.Machine$double.eps * matrix(rnorm(nrow(x)*length(preselection), 0, 1), nrow(x), length(preselection))
     f<-try(ssq.beta <- nnls.fit(x[,preselection,drop=F]+noise, y),silent=TRUE)
     noisefactor <- noisefactor+1
     print(noisefactor)
    }
 sigmasq <- 1e99
 if(noisefactor==100)
  {beta<-rep(0,dim(x)[2])
   return(beta)
  }
}
else
{
 	sigmasq <- mean((y-x[,preselection,drop=F] %*% ssq.beta)^2)
	noisefactor <- 0
} 
message("sigmasq: ", sigmasq)
	# regularize, if necessary:
	# add a small amount of noise

while (!is.finite(sigmasq)||(sigmasq >  var(y))) {
	message(noisefactor)
		sigmasq <- 0
		for (frzl in 1:10) {
		message(" -- ", frzl)
		noise <- 1e8*noisefactor*.Machine$double.eps * matrix(rnorm(nrow(x)*length(preselection), 0, 1), nrow(x), length(preselection))
		ssq.beta <- nnls.fit(x[,preselection,drop=F]+noise, y)
		sigmasq <- sigmasq + mean((y-x[,preselection,drop=F] %*% ssq.beta)^2)
		}
		sigmasq <- sigmasq / 10
		noisefactor <- noisefactor +1
	}
	if(sigmasq >  var(y))
	 {
	 	 sigmasq<-.5*var(y)
	 }	 
message("adjusted sigmasq: ", sigmasq, " with noise factor ", noisefactor)
	##### Added necessary precalculations:
sigmasq.Old<-sigmasq      


if(max(ssq.beta)<=.Machine$double.eps)
{return()
}

#	ssq.beta <-as.matrix( nnls.fit(as.matrix(x[,preselection2]), y))
#	sigmasq <- min(mean((y-as.matrix(x[,preselection2]) %*% (ssq.beta))^2),sigmasq)


if(gdf)
{
######(**)	
	##### Added necessary precalculations:
        # length of NNLS solution (full model) and the estimated df for that solutions in order to standardize solutions
	lengthNNLS<-sum(ssq.beta>.Machine$double.eps)  #number of positive coefficients in full models
	covEnd<-(x[,preselection,drop=F]	 %*% ssq.beta)*y
	dfEnd<-sum(covEnd)/sigmasq
}	
	predErrorFull<-sigmasq




	bic <- NULL;

if(includingZero)
{
	bic[1]<-n/predErrorFull*var(y)
}
	###### Added
	nnls.err <-NULL;
	###### Added
	df <-NULL;
	minbic.idx <- 0;
	biccount <- 0;

	### MAIN LOOP ###################################
	while((k < max.steps) & (length(active) < maxDf)) {
		action <- NULL
		k <- k + 1
		C <- Cvec[inactive]
		### identify the largest nonactive gradient
		if (type=="plasso") {
			Cmax <- max(C)
			if (Cmax <= 0)
				break; # nowhere left where we can move without violating the constraint
		} else {
			Cmax <- max(abs(C))
		}
		### Check if we are in a DROP situation
		if(!any(drops)) {
			if (type=="plasso") {
				new <- C >= Cmax - eps # see Efron et. al (2003), section 3.
			} else {
				new <- abs(C) >= Cmax - eps
			}
			C <- C[!new]	# for later
			new <- inactive[new]	# Get index numbers

			### We keep the choleski R  of X[,active] (in the order they enter)
			for(inew in new) {
				if(use.Gram) {
					R <- updateR(
						Gram[inew, inew], 
						R, 
						drop(Gram[inew, active]), 
						Gram=TRUE,
						eps=eps
					)
				} else {
					R <- updateR(
						x[, inew],
						R,
						x[, active],
						Gram=FALSE,
						eps=eps
					)
				}
				if(attr(R, "rank") == length(active)) {
					##singularity; back out
					nR <- seq(length(active))
					R <- R[nR, nR, drop = FALSE]
					attr(R, "rank") <- length(active)
					ignores <- c(ignores, inew)
					action <- c(action,  - inew)
					if(trace)
						cat("LARS Step", k, ":\t Variable", inew, 
							"\tcollinear; dropped for good\n")
				} else {
					if(first.in[inew] == 0)
						first.in[inew] <- k
					active <- c(active, inew)
					#NN# if added
					if (type=="plasso") {
						Sign <- c(Sign, 1)
					} else {
						Sign <- c(Sign, sign(Cvec[inew]))
					}
					action <- c(action, inew)
					if(trace)
						cat("LARS Step", k, ":\t Variable", inew, 
							"\tadded\n")
				}
			}
		} else {
			action <-  - dropid
		}
		Gi1 <- backsolve(R, backsolvet(R, Sign))	
		### Now we have to do the forward.stagewise dance
		### This is equivalent to NNLS
		dropouts<-NULL
		A <- 1/sqrt(sum(Gi1 * Sign))
		w <- A * Gi1	# note that w has the right signs
		if(!use.Gram) u <- drop(x[, active, drop = FALSE] %*% w)	###
		### Now we see how far we go along this direction before the
		### next competitor arrives. There are several cases
		###
		### If the active set is all of x, go all the way
		if(length(active) >=  min(n-1, m - length(ignores) ) ) {
			gamhat <- Cmax/A
		} else {
			if(use.Gram) {
				a <- drop(w %*% Gram[active,  - c(active,ignores), drop = FALSE])
			}
			else {
				a <- drop(u %*% x[,  - c(active, ignores), drop=FALSE])
			}
			#NN# if plasso
			if (type=="plasso"){
				gam <- c((Cmax - C)/(A - a))
			} else {
				gam <- c((Cmax - C)/(A - a), (Cmax + C)/(A + a))
			}	
			### Any dropouts will have gam=0, which are ignored here
			#NN# if plasso
			if (type=="plasso"){
				gamhat <- min(gam[gam > eps])
			} else {
				gamhat <- min(gam[gam > eps], Cmax/A)
			}	
		}
		if(type == "lasso"|type=="plasso") {
			dropid <- NULL
			b1 <- beta[k, active]	# beta starts at 0
			z1 <-  - b1/w
			zmin <- min(z1[z1 > eps], gamhat)
			if(zmin < gamhat) {
				gamhat <- zmin
				drops <- z1 == zmin
			}
			else drops <- FALSE
		}
		beta[k + 1,  ] <- beta[k,  ]
		beta[k + 1, active] <- beta[k + 1, active] + gamhat * w
		if(use.Gram) {
			Cvec <- Cvec - gamhat * Gram[, active, drop = FALSE] %*% w
		}
		else {
			residuals <- residuals - gamhat * u
			Cvec <- drop(t(residuals) %*% x)
		}
		Gamrat <- c(Gamrat, gamhat/(Cmax/A))
		arc.length <- c(arc.length, gamhat)	
		### Check if we have to drop any guys
		if((type == "lasso"|type=="plasso") && any(drops)) {
			dropid <- seq(drops)[drops] # convert logical -> numbers
			for(id in rev(dropid)) {
				if(trace)
				cat("Lasso Step", k+1, ":\t Variable",
					active[id], "\tdropped\n")
				R <- downdateR(R, id)
			}
			dropid <- active[drops]	# indices from 1:m
			beta[k+1,dropid]<-0  # added to make sure dropped coef is zero
			active <- active[!drops]
			Sign <- Sign[!drops]
		}
		if(!is.null(vn))
			names(action) <- vn[abs(action)]
		actions[[k]] <- action
	####Added for Extended Fractional Averagine

if(EFA)
{
  if(is.finite(active[k]))
  { if(((active[k]%%2)==0))
        ignores<-c(ignores,(active[k]-1))
    if(((active[k]%%2)==1))
        ignores<-c(ignores,(active[k]+1))
  }      
}
	#### End Change for Extended Fractional Averagine

		inactive <- im[ - c(active, ignores)]

		##### Change in df estimation (now using Ye) and in stopping criterion
                ##### Added: if and gdf estimation
		if(gdf){
			if(is.finite((max(beta))))
				{
         xbetahat<-x%*%beta[k+1,] #calculate X Betahat for given k
				}
			else
        {
         print("non-finite max(beta)")
         nnls.beta<-nnls.fit(x[,which(beta[k+1,]>0),drop=F], y);
			   xbetahat<-x[,which(beta[k+1,]>0),drop=F]%*%nnls.beta
			  }
				
			cov<-xbetahat*y          #calculated cov(X Betahat(i), y(i))



			df[k]<-sum(cov)/sigmasq   
			df[k]<-df[k]*(lengthNNLS/dfEnd) #standardize such that full model has df of full model
					  # to account for innaccuracy in cov estimation
		}
		else {
			df[k]<-sum(beta[k+1,]!=0)
		}
		##### Addition end
		# get beta from nnls.fit and calcualte rss
		beta.nnls <- nnls.fit(x[,which(beta[k+1,]>0),drop=F], y);
		nnls.estimate <- x[,which(beta[k+1,]>0),drop=F] %*% beta.nnls;
		nnls.residual <- y - nnls.estimate;
		nnls.err[k] <- mean(nnls.residual^2);

		######try if this helps:
		if (nnls.err[k] < sigmasq)
			{nnls.err[k] <- sigmasq
			}

    if(includingZero)
    {
                ###### change bic to include df estimate from further up
		     bic[k+1] <- (n/sigmasq)*(nnls.err[k]+((log(n)*df[k]*sigmasq)/n))
    }
    else
    {
     bic[k] <- (n/sigmasq)*(nnls.err[k]+((log(n)*df[k]*sigmasq)/n))
    }
                ###### Added if and Exact Criterion
		if (bic.steps==0){
			#calculate lowest possible bic at that point (so current df, but min possible pred. error)
			#so pred Error of full model
			possibleBicMin<-(n/sigmasq)*(predErrorFull+((log(n)*df[k]*sigmasq)/n))

			
			if ( ( k>1 ) && ( bic[minbic.idx]<possibleBicMin ) && ((sigmasq.Old-sigmasq)/sigmasq <10  ) ) {
				break
			}
			else{#minBic is searched and stored
				minbic.idx <- max(which(bic == min(bic)));
			}
				

		}
		##### Addition ended
		else{	sigmasq.Old<-sigmasq
			minbic.idx.old <- minbic.idx;
		#browser();
			minbic.idx <- max(which(bic == min(bic)));
			if (minbic.idx == minbic.idx.old) {
				biccount <- biccount + 1;
				if (biccount == bic.steps)
					break
			} else {
				biccount <- 1;
			}
		}
	}
#	beta <- beta[seq(k + 1),  ]	#
if(includingZero)
{
beta <- beta[minbic.idx,,drop=F] 
}
else
{
beta <- beta[minbic.idx+1,,drop=F] 
}

#	dimnames(beta) <- list(paste(0:k), vn)	### Now compute RSS and R2
#	if(trace)
#		cat("Computing residuals, RSS etc .....\n")
#	residuals <- y - x %*% t(beta)
	beta <- scale(beta, FALSE, normx)
#	RSS <- apply(residuals^2, 2, sum)
	#Problem with RSS for plasso by the fact that the last estimates do give some weird results
#	R2 <- 1 - RSS/RSS[1]
#	Cp <- ((n - k - 1) * RSS)/rev(RSS)[1] - n + 2 * seq(k + 1)
# 	object <- list(call = call, type = TYPE, R2 = R2, RSS = RSS, Cp = Cp, 
# 			actions = actions[seq(k)], entry = first.in, Gamrat = Gamrat, 
# 			arc.length = arc.length, Gram = if(use.Gram) Gram else NULL, 
# 			beta = beta, mu = mu, normx = normx, meanx = meanx, bic=bic)
# 	class(object) <- "lars"
        ###### added return information of k
	object <- list(call=call, type="plasso", beta=beta, steps=minbic.idx,k=k,bic=bic,df=df,nnls.err=nnls.err,vary=var(y),sigma=sigmasq,n=n);
	object
}

ams.pp.pl.slidingMaxAdjusted <-
function(result, charge.state.wise=F, n=3)
{peaks<-matrix(NA,nrow=length(result[,1]),ncol=7)
 peaks[,1]<-result[,1]
 peaks[,2]<-result[,1]
 peaks[,5]<-result[,2]
 peaks[,6]<-result[,3]
 peaks[,7]<-result[,4]
 print(result)
 print(dim(peaks))
	discardPeaks <- function(p, n)
	{
		keep <- NULL;
		current.row <- 1;
		while(current.row <= nrow(p)) {
			# p is sorted; so it suffices to look
			# (n-1)/2 bins ahead 
			neighborhood <- which( 
				p[current.row:nrow(p),2] 
				<= p[current.row,2]+(n-1)/2 
			) + current.row -1;
			# find max
 			sul<-sum(p[(p[neighborhood, 7]==1),6])
			nonsul<-sum(p[(p[neighborhood, 7]==2),6])
			midsul<-sum(p[(p[neighborhood, 7]==0),6])
			if (nonsul+sul+midsul==0)
				{sulCont<-0.0417  #from Averagine
				}
			else	{sulCont<-sul/(nonsul+sul+midsul)
				}
			#print(cbind(sulCont,nonsul,sul))
			is.max <- which.max(p[neighborhood, 6]);
			keep <- c(keep, neighborhood[is.max]);
			current.row <- max(neighborhood)+1;
			p[neighborhood[is.max],7]<-sulCont
			
		}
		
		return(p[keep,]);
	}

	# make sure peak list is sorted by mass
	if (is.unsorted(peaks[,1])) {
		peaks <- peaks[sort(peaks[,1], index.return=T)$ix,];
	}

	if (charge.state.wise) {
		# split data charge state wise
		ret <- NULL;
		for (i in sort(unique(peaks[,5]))) {
			ret <- rbind(ret, discardPeaks(peaks[peaks[,5]==i,], n));
		}
		# re-sort by mass
		ret <- ret[sort(ret[,1], index.return=T)$ix,];
	} else {
		ret <- discardPeaks(peaks, n)
	}
 	ret<-ret[,c(1,5,6,7)]
	print(ret)
	return(ret);
}

ams.pp.buildModelMatrix<-function(begin,end,offset,data, EFA=TRUE,maxRangeSize=1,thresholdInt=0,limit=1e-26, charge=c(2,3,4,5), width=width)
{   if (begin<=offset)
      { offsetLower<-begin-1  #set lower offset zero if begin <offset
      }
    else
      { offsetLower<-offset
      }
    if(end+offset>length(data[,1]))
      { offsetUpper<-length(data[,1])-end  #set upper offset zero if begin <offset
      }
    else
      { offsetUpper<-offset
      }


    leng<-end-begin+offsetLower+offsetUpper+1


    lastModelBuilt<-0
    xCombined<-NULL
    iCollection<-matrix(nrow=0,ncol=5)
    preselection<-NULL
  
    for (i in (begin+1):(end-1)) #find all local maxima which are above a certain threshold
      { if ((data[i,2]>data[i-1,2]) &(data[i,2]>data[i+1,2])&(data[i,2]>thresholdInt))
         {  if((i-lastModelBuilt>=maxRangeSize)||lastModelBuilt==0)
            { lastModelBuilt<-i
              if(EFA)
                { modelsPerBin<-length(charge)*2
                  xChargeMatrix<-matrix(nrow=leng,ncol=modelsPerBin)
                  maxXPeak<-vector(length=modelsPerBin)
                  monoisotopic<-vector(length=modelsPerBin)

                 for(m in 1:modelsPerBin)
                   {  if((floor(m/2)-m/2)==0)
                        {  SInd<-"Y"
                        }
                      else
                       {  SInd<-"N"
                       }
                     xChargefftGeneral<-buildAveragineModelShort(data[i,1], data[(begin-offsetLower):(end+offsetUpper),1],charge[floor((m+1)/2)],S=SInd,width=width)
                     xChargefft<-xChargefftGeneral[[1]]  #can be reused!!
                     x2<-Re(fft(xChargefft,inv=T))[1:leng]
                     maxXPeak[m]<-findMaxPeakAndPosition(cbind(c(1:(length(x2))),x2))[2]
                     monoisotopic[m]<-xChargefftGeneral[[2]]
                     xChargeMatrix[,m]<-x2
                  }

                }
              else
               {  modelsPerBin<-length(charge)
                  xChargeMatrix<-matrix(nrow=leng,ncol=modelsPerBin)
                  maxXPeak<-vector(length=modelsPerBin)
                  monoisotopic<-vector(length=modelsPerBin)

                  for(m in 1:modelsPerBin)
                    { SInd<-"Ave"
                       xChargefftGeneral<-buildAveragineModelShort(data[i,1], data[(begin-offsetLower):(end+offsetUpper),1],charge[m],S=SInd,width=width)
                       xChargefft<-xChargefftGeneral[[1]]  #can be reused!!
                       x2<-Re(fft(xChargefft,inv=T))[1:leng]
                       maxXPeak[m]<-findMaxPeakAndPosition(cbind(c(1:(length(x2))),x2))[2]
                       monoisotopic[m]<-xChargefftGeneral[[2]]
                       xChargeMatrix[,m]<-x2
                    }
                }
             }

            if(((i-1)>max(iCollection[,1],0)))
              { xAdd<-NULL
                for(m in 1:modelsPerBin)
                 {  xAdd<-cbind(xAdd,xMoved(i-begin,xChargeMatrix[,m],maxXPeak[m],offsetLower,offsetUpper))
                    iCollection<-rbind(iCollection,c(i-1,charge[(floor((m+1)/2))*EFA+m*(1-EFA)],2-2*(m/2-floor(m/2)),monoisotopic[m],maxXPeak[m]))
                 }
                xCombined<-cbind(xCombined,xAdd)
              }
            xAdd<-NULL
            for(m in 1:modelsPerBin)
              { xAdd<-cbind(xAdd,xMoved(i-begin+1,xChargeMatrix[,m],maxXPeak[m],offsetLower,offsetUpper))
                 iCollection<-rbind(iCollection,c(i,charge[(floor((m+1)/2))*EFA+m*(1-EFA)],2-2*(m/2-floor(m/2)),monoisotopic[m],maxXPeak[m]))
                   }
            xCombined<-cbind(xCombined,xAdd)
            if(!EFA)
              preselection<-c(preselection,(dim(xCombined)[2]-(modelsPerBin-1)):dim(xCombined)[2])
            if(EFA)
              preselection<-c(preselection,((dim(xCombined)[2]-(modelsPerBin-1)):dim(xCombined)[2])[seq(2,modelsPerBin,2)])
              
             xAdd<-NULL
            for(m in 1:modelsPerBin)
              {  xAdd<-cbind(xAdd,xMoved(i-begin+2,xChargeMatrix[,m],maxXPeak[m],offsetLower,offsetUpper))
                 iCollection<-rbind(iCollection,c(i+1,charge[(floor((m+1)/2))*EFA+m*(1-EFA)],2-2*(m/2-floor(m/2)),monoisotopic[m],maxXPeak[m]))
              }
            xCombined<-cbind(xCombined,xAdd)
 
        }
     }
  beginWithOffset<-(begin-offsetLower)
  endWithOffset<-(end+offsetUpper)
  ret <- list(
    xCombined=xCombined,
    preselection=preselection,
    iCollection=iCollection,
    beginWithOffset=beginWithOffset,
    endWithOffset=endWithOffset
  )
  class(ret) <- "ams.pp.strap.model"
  return(ret)
}


xMoved<-function(i,x,maxXPeak,offsetLower,offsetUpper)
{distance<-i-maxXPeak+offsetLower #Rotating the xVector such that its peak corresponds to the peak of the filteredSignal
   lengthX<-length(x)
   xMoved<-c( rep(0,max(distance,0)),
              x[max(-distance+1,0):min(lengthX,lengthX-distance)],
              rep(0,max(-distance,0))
            )
   return(xMoved)
}

\name{predict.ams.pp.strap.model}
\alias{predict.ams.pp.strap.model}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ ~~function to do ... ~~ }
\description{
  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
predict.ams.pp.strap.model(model, EFA = TRUE, data, bic.steps = 0, gdf = TRUE, includingZero = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{model}{ ~~Describe \code{model} here~~ }
  \item{EFA}{ ~~Describe \code{EFA} here~~ }
  \item{data}{ ~~Describe \code{data} here~~ }
  \item{bic.steps}{ ~~Describe \code{bic.steps} here~~ }
  \item{gdf}{ ~~Describe \code{gdf} here~~ }
  \item{includingZero}{ ~~Describe \code{includingZero} here~~ }
}
\details{
  ~~ If necessary, more details than the description above ~~
}
\value{
  ~Describe the value returned
  If it is a LIST, use
  \item{comp1 }{Description of 'comp1'}
  \item{comp2 }{Description of 'comp2'}
  ...
}
\references{ ~put references to the literature/web site here ~ }
\author{ ~~who you are~~ }
\note{ ~~further notes~~ 
}
\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
\keyword{ multivariate }

\name{ams.pp.getRegions.MeanFilter}
\alias{ams.pp.getRegions.MeanFilter}
\title{Determine relevant regions}
\description{
  Reimplementation of Golotvin's / Kaur's method for relevant region detection.
}
\usage{
ams.pp.getRegions.MeanFilter(spectrum, mz.nIntervals, mz.neighborhood, noise.threshold.factor)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{spectrum}{The spectrum in which one searches for relevant regions}
  \item{mz.nIntervals}{The number of intervals the spectrum is divided in}
  \item{mz.neighborhood}{the size of the m/z neighborhood}
  \item{noise.threshold.factor}{the noise threshold factor}
}
\details{
 All details are available in the supplementary material of Kirchner et al. Bioinformatics (2007)
}
\value{
  Relevant regions vector: FALSE == relevant.
}
%\references{ ~put references to the literature/web site here ~ }
\author{ Marc Kirchner \email{marc.kirchner@iwr.uni-heidelberg.de} }
\examples{}
\keyword{multivariate}

\name{runPostProc}
\alias{runPostProc}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{postprocessing based on local maxima detection in neighborhood}
\description{
postprocessing by applying local maxima detection}
\usage{
runPostProc(width,quant=0,g=3,pathIn,pathOut,mz.bin=mz.bins, chargestates=c(1,2,3,4,5,6),database=FALSE,recalc=FALSE,databasePath=NULL,threshCounts=0)}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{width}{peak width}}
  \item{quant}{lower quantile of the intensity of peaks which should be disregarded}
  \item{g}{size of the neighborhood (also called G)}
  \item{pathIn}{Path where results from peak detection are to be found}
  \item{pathOut}{swhere results should be stored}
  \item{mz.bin}{binning scheme of the spectrum}
  \item{chargestates}{charges occuring in the spectrum}
  \item{database}{if mz-values should be compared to possible values from database}
  \item{recalc}{if computation of possible values shoud be retrieved}
  \item{databasePath}{where database is to be found}
  \item{threshCount}{how often peptide at a mz-bin needs to be counted so that mass is accepted in postprocessing}
}
\details{
  FILL ME OUT.
}
\value{
	A peak list, consisting of all local maxima, according to the 
	given parameterization.
}
%\references{ ~put references to the literature/web site here ~ }
\author{Marc Kirchner \email{marc.kirchner@iwr.uni-heidleberg.de}}
\examples{}
\keyword{multivariate}

\name{ams.pp.internal}
\alias{ams.pp.bins2breaks}
\alias{ams.pp.boolean2range}
\alias{ams.pp.strap.lars}
\alias{nnls.fit}
\alias{peaks}
\alias{getDistributionHBin}
\alias{buildAveragineModelShort}
\alias{sulveragine}
\alias{findMaxPeakAndPositionUns}
\alias{exactAveragine}
\alias{joinAdjacent}
\alias{lightAveragine}
\alias{findMaxPeakAndPosition}
\alias{fftDiscrete}
\alias{xMoved}
\title{ ams.pp internal functions }
\description{
  Internal functions.
}
%\usage{
%ams.pp.bins2breaks(bins)
%}
%%- maybe also 'usage' for other objects documented here.
%\arguments{
%  \item{bins}{ ~~Describe \code{bins} here~~ }
%}
%\details{
%  ~~ If necessary, more details than the description above ~~
%}
%\value{
%  ~Describe the value returned
%  If it is a LIST, use
%  \item{comp1 }{Description of 'comp1'}
%  \item{comp2 }{Description of 'comp2'}
%  ...
%}
%\references{ ~put references to the literature/web site here ~ }
\author{Marc Kirchner \email{marc.kirchner@iwr.uni-heidelberg.de} }
\examples{}
\keyword{multivariate}

\name{ams.pp.runSingleRegression}
\alias{ams.pp.runSingleRegression}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ ~~function to do ... ~~ }
\description{
  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
ams.pp.runSingleRegression(data, bins, charges = c(2, 3, 4, 5), thresholdR2, width = 1e-04, sulLevels = 3, thresholdBetaHat = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{ ~~Describe \code{data} here~~ }
  \item{bins}{ ~~Describe \code{bins} here~~ }
  \item{charges}{ ~~Describe \code{charges} here~~ }
  \item{thresholdR2}{ ~~Describe \code{thresholdR2} here~~ }
  \item{width}{ ~~Describe \code{width} here~~ }
  \item{sulLevels}{ ~~Describe \code{sulLevels} here~~ }
  \item{thresholdBetaHat}{ ~~Describe \code{thresholdBetaHat} here~~ }
}
\details{
  ~~ If necessary, more details than the description above ~~
}
\value{
  ~Describe the value returned
  If it is a LIST, use
  \item{comp1 }{Description of 'comp1'}
  \item{comp2 }{Description of 'comp2'}
  ...
}
\references{ ~put references to the literature/web site here ~ }
\author{ ~~who you are~~ }
\note{ ~~further notes~~ 
}
\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
\keyword{ multivariate }

\name{ams.pp.buildModelMatrix}
\alias{ams.pp.buildModelMatrix}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ ~~function to do ... ~~ }
\description{
  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
ams.pp.buildModelMatrix(begin, end, offset, data, EFA = TRUE, maxRangeSize = 1, thresholdInt = 0, limit = 1e-26, charge = c(2, 3, 4, 5), width = width)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{begin}{ ~~Describe \code{begin} here~~ }
  \item{end}{ ~~Describe \code{end} here~~ }
  \item{offset}{ ~~Describe \code{offset} here~~ }
  \item{data}{ ~~Describe \code{data} here~~ }
  \item{EFA}{ ~~Describe \code{EFA} here~~ }
  \item{maxRangeSize}{ ~~Describe \code{maxRangeSize} here~~ }
  \item{thresholdInt}{ ~~Describe \code{thresholdInt} here~~ }
  \item{limit}{ ~~Describe \code{limit} here~~ }
  \item{charge}{ ~~Describe \code{charge} here~~ }
  \item{width}{ ~~Describe \code{width} here~~ }
}
\details{
  ~~ If necessary, more details than the description above ~~
}
\value{
  ~Describe the value returned
  If it is a LIST, use
  \item{comp1 }{Description of 'comp1'}
  \item{comp2 }{Description of 'comp2'}
  ...
}
\references{ ~put references to the literature/web site here ~ }
\author{ ~~who you are~~ }
\note{ ~~further notes~~ 
}
\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
\keyword{multivariate}

\name{ams.pp.slidingMaxAdjusted}
\alias{ams.pp.slidingMaxAdjusted}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Apply a local maximum postprocessing filter to a peak list}
\description{
  Implements a local maximum postprocessing filter for peak lists.
}
\usage{
ams.pp.slidingMaxAdjusted(peaks, charge.state.wise = F, n = 3)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{peaks}{peak list (as returned from \code{ams.pp.strap.getPeakList}}
  \item{charge.state.wise}{charge state-wise application of the filter?}
  \item{n}{size of the neighborhood (also called G)}
}
\details{
  FILL ME OUT.
}
\value{
	A peak list, consisting of all local maxima, according to the 
	given parameterization.
}
%\references{ ~put references to the literature/web site here ~ }
\author{Marc Kirchner \email{marc.kirchner@iwr.uni-heidleberg.de}}
\examples{}
\keyword{multivariate}
